#ifndef __WebDicDll_h
#define	__WebDicDll_h

#define	WDF_IMMEDIATE	0x0001      // Update popup window immediately
#define	WDF_RANDOM_WALK	0x0002		// [not supported yet]
#define	WDF_ON_THE_FLY	0x0004		// [not supported yet]
#define	WDF_RELATED		0x0008		// Search related words on popup window

struct TWDEnumerate {
	const tchar *name;
	const tchar *filekeyword;
	const char *url;
	int expires;	// [sec]
	int flags;		// combination of WDF_xxx
};

struct TWDResponse {
	BSTR pron;
	BSTR japa;
	BSTR exp;
	BSTR filelinks[16];	// file link filenames, up to 16
	int *cancelReq;
	HANDLE hEvent;		// not supported;
	TWDResponse();
	~TWDResponse();
};

typedef int (*FNWDHttpReq)(const char *url, BSTR *res);
typedef int (*FNWDGetHttpFile)(const char *url, const char *param, const tchar *path);

struct TWDInetAccess {
	FNWDHttpReq HttpReq;
	FNWDGetHttpFile GetHttpFile;
	TWDInetAccess();
};

#ifdef __cplusplus
extern "C" {
#endif
typedef int (WINAPI *FNWDEnumerate)(int index, TWDEnumerate *param);
typedef int (WINAPI *FNWDRequest)(int index, const tchar *srch_word, TWDResponse *resp, const tchar *dictionary_name, TWDInetAccess *inet);
#ifdef __cplusplus
}
#endif


#endif	/* __WebDicDll_h */

