//---------------------------------------------------------------------------
#include "tnlib.h"
#pragma hdrstop
#include <oleauto.h>

#include "defs.h"
#include "gooVoice.h"
#include "WebDicDll.h"
#include "HTMLParser.h"
#include "sowUtil.h"

#include "pdstrlib.h"
#include "filestr.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

#define	VOFILE_DIR		_t("VoiceFiles")
#define	VOFILE_PREFIX	_t("c2_")

TWDEnumerate Properties[] = {
	{ _t("goo voice(EJ)"), _t("!gooVoice"), "http://dictionary.goo.ne.jp/search.php?MT=%s&kind=ej&mode=1&kwassist=0", -1, WDF_IMMEDIATE|WDF_RELATED },
	{ NULL }
};

//
// TGooParser class
//
class TGooParser : public THtmlStreamParser {
typedef THtmlStreamParser super;
protected:
	virtual void startTag(const tchar *tagtop, const tchar *end);
	virtual void rawText(const tchar *text, int len);
	virtual void commentText(const tchar *text, int len);
public:
	tnstr VoiceUrl;
	tnstr VoiceUrlWav;
};

void TGooParser::startTag(const tchar *tagtop, const tchar *end)
{
	rawText(tagtop, STR_DIFF(end,tagtop));
}

// TGooParser class //
void TGooParser::rawText(const tchar *text, int len)
{
	bool wav = false;
	const tchar *p = text;
	const tchar *endp = text+len;
	while (p<endp){
		if (*p=='.'){
			if (!_tcsncmp(p+1, _t("mp3"), 3)){
				break;
			}
			if (!_tcsncmp(p+1, _t("wav"), 3)){
				wav = true;
				break;
			}
		}
		p++;
	}
	if (p>=endp)
		return;

	const tchar *tail = p+4;
	while (p>=text){
		tchar c = *p;
		if (c=='=' || c=='"' || c=='\''){
			p++;
			break;
		}
		p--;
	}
	if (wav){
		VoiceUrlWav.set(p, STR_DIFF(tail, p));
	} else {
		VoiceUrl.set(p, STR_DIFF(tail, p));
		AbortReq = true;
	}
}

void TGooParser::commentText(const tchar *text, int len)
{
	rawText(text, len);
}


int gooRequestData(int index, const tchar *srch_word, TWDResponse *resp, const tchar *dictionary_name, TWDInetAccess *inet)
{
	tnstrA srchU;
	{
		tnstr temp;
		tnstrA temp;
		temp.setUTF8(srch_word);	// UTF-16->UTF-8
		EscapeURIString(temp, srchU);	// escape
	}
	__tnstrA url = tnsprintfA(Properties[index].url, srchU.c_str());
	BSTR res;
	//DBW("goo:%s", url.c_str());
	if (!inet->HttpReq(url, &res)){
		return 0;
	}
	tnstr text1;
#if 0
	TOFileA file;
	file.create(_t("capture.html"));
	file.putline(res);
	file.close();
#endif
	text1.setAnsi((char*)res);	//TODO: res text may be euc
	SysFreeString(res);

	if (*resp->cancelReq){
		return 0;
	}

	bool ok = false;
	TGooParser parser;
	if (parser.openBuffer(text1)){
		parser.parse();
		const tchar *src_voiceurl = _t("");
		if (parser.VoiceUrl.exist())
			src_voiceurl = parser.VoiceUrl;	// mp3
//		else
//			src_voiceurl = parser.VoiceUrlWav;	// wav
		if (src_voiceurl[0]){
			// Download voice file
			// t@C͏㏑
			__tnstrA src_voiceurlA; src_voiceurlA.setAnsi(src_voiceurl);	// euc...
			__tnstrA voiceurl = MakeUrl(url, src_voiceurlA);
			tnstr voicefile = MakeVoiceFile(dictionary_name, src_voiceurlA, VOFILE_DIR, VOFILE_PREFIX);
			tnstr linkname = GetFileName(voicefile);

			if (inet->GetHttpFile(voiceurl, "", voicefile)==0
				|| fexist(voicefile)	//Note: voicefileقŎgpŃG[ɂȂ\邽
				){
				resp->filelinks[0] = SysAllocString(linkname);
				ok = true;
			}
		}
	}

	if (*resp->cancelReq || !ok){
		return 0;
	}

	return 1;
}

