//---------------------------------------------------------------------------

#ifndef HtmlParserH
#define HtmlParserH
//---------------------------------------------------------------------------

class tnstr;

class THtmlParser {
protected:
	bool AbortReq;
public:
	THtmlParser()
	{
		AbortReq = false;
	}
	virtual bool getline(tnstr &s) = 0;
	bool parse();
	inline bool isword(tchar c)
	{
		return (c>='A'&&c<='Z') || (c>='a'&&c<='z');
	}
	void parseTag(const tchar *tag, const tchar *end, tnstr_map &attrs);
	tnstr getTagAttr(const tchar *tag, const tchar *tag_end, const tchar *attr_name);
protected:
	//TODO: tag͕̍sɂ܂ĕf\邽ߗv
	// tagKvƂꍇAʓrobt@pӂKv
	virtual void startTag(const tchar *tagtop, const tchar *end){}
	virtual void endTag(const tchar *tagtop, const tchar *end){}
	virtual void startComment(const tchar *text){}
	virtual void endComment(const tchar *end){}
	virtual void rawText(const tchar *text, int len){}
	virtual void commentText(const tchar *text, int len){}
};

class THtmlStreamParser : public THtmlParser {
typedef THtmlParser super;
protected:
	tnstr FileName;
	TIFile File;
	const tchar *Buffer;	// reference
public:
	THtmlStreamParser()
	{
		Buffer = NULL;
	}
	bool open(const tchar *filename);
	bool openBuffer(const tchar *str);
	bool getline(tnstr &s);
protected:
#if 0	// for debug
	virtual void startTag(const tchar *tagtop, const tchar *end);
	virtual void endTag(const tchar *tagtop, const tchar *end);
	virtual void startComment(const tchar *text);
	virtual void endComment(const tchar *end);
	virtual void rawText(const tchar *text, int len);
	virtual void commentText(const tchar *text, int len);
#endif
};

#endif

