#include "tnlib.h"
#pragma hdrstop

#include "sowUtil.h"
#include "filestr.h"
#include "pdstrlib.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

// base_url : http://hoge.com/xxx
// objurl : [http://hoge.com]/dir/voice.mp3
__tnstrA MakeUrl(const char *base_url, const char *objurl)
{
	__tnstrA voiceurl;

	const char *endhost = FindUrlObjPos(base_url);
	if (endhost){
		voiceurl.set(base_url, FP_DIFF(endhost, base_url));
	} else {
		voiceurl = base_url;
	}
	endhost = FindUrlObjPos(objurl);
	if (endhost){
		voiceurl = objurl;
	} else {
		voiceurl += objurl;
	}
	return voiceurl;
}

// dicname : dictionary full path
// src_voiceurl : /dir/voice.mp3
tnstr MakeVoiceFile(const tchar *dicname, const char *src_voiceurl, const tchar *save_dir, const tchar *prefix)
{
	tnstr voicefile(_GetFilePath(dicname));
	voicefile += save_dir;
	if (voicefile && voicefile[0]){
		_tmkdir(voicefile);
		voicefile += _t("\\");
	}
	const char *objurl = FindUrlObjPos(src_voiceurl);
	if (objurl){
		src_voiceurl = objurl;
	}
	tnstr urlW; urlW.setUTF8(src_voiceurl);
	tnstr filename;
	if (prefix)
		filename = prefix;
	filename += urlW[0]=='/' ? &urlW[1] : urlW.c_str();
	voicefile += replace(filename, _t("/"), _t("_"));
	return voicefile;
}

const char *FindUrlObjPos(const char *url)
{
	const char *endhost = strstr(url, "://");	// find schemer
	if (!endhost)
		return NULL;	// url is obj url
	endhost += 3;
	while (*endhost=='/') endhost++;
	endhost = strchr(endhost, '/');
	if (endhost){
		return endhost;	// top of the obj url
	} else {
		return NULL;	// url is obj url
	}
}

